<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class relFechamentoCupomPendente  {

    protected $relFechamentoCupomPendente;
    protected $utilService;
    
    public function __construct(Services\relFechamentoCupomPendente $relFechamentoCupomPendente, Utilities\Util $utilService) {
        $this->relFechamentoCupomPendente = $relFechamentoCupomPendente;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $conditions = $this->utilService->getParamsAsArray($request);
        $this->conditionsMake($conditions);
        $result = $this->relFechamentoCupomPendente->find($conditions['CDFILIAL'], $conditions['IDORIGEMREDZ'], $conditions['CDCAIXA'], $conditions['DATAINI'], $conditions['DATAFIN'], $conditions['STATUS'], $conditions['NRORG'], $conditions['CDOPERADOR']);
        $response->addDataSet(new DataSet("vnd55016_relFechamentoCupomPendente", $result));
        return $response;
    }

    public function conditionsMake(&$conditions){
        if (isset($conditions['CDFILIAL'])){
            if(is_array($conditions['CDFILIAL'])){
                $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
            }
            else{
                $conditions['CDFILIAL'] = 'T';
            }
        }else{
            $conditions['CDFILIAL'] = 'T';
        }
        if (isset($conditions['CDCAIXA'])){
            if(is_array($conditions['CDCAIXA'])){
                $conditions['CDCAIXA'] = implode('_', $conditions['CDCAIXA']);
            }
            else{
                $conditions['CDCAIXA'] = 'T';
            }
        }else{
            $conditions['CDCAIXA'] = 'T';
        }
        if (isset($conditions['DTENTRVENDA'])){
            $conditions['DATAINI'] = $conditions['DTENTRVENDA'][0];
            $conditions['DATAFIN'] = $conditions['DTENTRVENDA'][1];
        }
        else{
            $conditions['DATAINI'] = null;
            $conditions['DATAFIN'] = null;
        }
        if (!isset($conditions['IDORIGEMREDZ'])){
            $conditions['IDORIGEMREDZ'] = 'T';
        }
        if (isset($conditions['IDSTATUS'])){
            $conditions['STATUS'] = $conditions['IDSTATUS'];
        }
        else{
            $conditions['STATUS'] = 'P_E';
        }
    }
}